commit 52dd840c5eba25ef54dee3f1c78f371032a7c051
Author: Patrick Palka <ppalka@redhat.com>
Date:   Wed Aug 18 14:37:42 2021

    c++: ignore explicit dguides during NTTP CTAD [PR101883]
    
    Since (template) argument passing is a copy-initialization context,
    we mustn't consider explicit deduction guides when deducing a CTAD
    placeholder type of an NTTP.
    
            PR c++/101883
    
    gcc/cp/ChangeLog:
    
            * pt.c (convert_template_argument): Pass LOOKUP_IMPLICIT to
            do_auto_deduction.
    
    gcc/testsuite/ChangeLog:
    
            * g++.dg/cpp2a/nontype-class49.C: New test.
    
    (cherry picked from commit a6b3db3e8625a3cba1240f0b5e1a29bd6c68b8ca)

diff --git a/gcc/cp/pt.c b/gcc/cp/pt.c
index 45f39ab7fff..077097d9175 100644
--- a/gcc/cp/pt.c
+++ b/gcc/cp/pt.c
@@ -8514,7 +8514,8 @@ convert_template_argument (tree parm,
 	   can happen in the context of -fnew-ttp-matching.  */;
       else if (tree a = type_uses_auto (t))
 	{
-	  t = do_auto_deduction (t, arg, a, complain, adc_unify, args);
+	  t = do_auto_deduction (t, arg, a, complain, adc_unify, args,
+				 LOOKUP_IMPLICIT);
 	  if (t == error_mark_node)
 	    return error_mark_node;
 	}
diff --git a/gcc/testsuite/g++.dg/cpp2a/nontype-class49.C b/gcc/testsuite/g++.dg/cpp2a/nontype-class49.C
new file mode 100644
index 00000000000..c83e4075ed0
--- /dev/null
+++ b/gcc/testsuite/g++.dg/cpp2a/nontype-class49.C
@@ -0,0 +1,8 @@
+// PR c++/101883
+// { dg-do compile { target c++20 } }
+
+template<class T> struct C { constexpr C(int) { } };
+explicit C(int) -> C<int>;
+
+template<C c> struct X { };
+X<1> x; // { dg-error "deduction|no match" }

